﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.01
@EndOfDesignText@
Sub Class_Globals
	Private fx As JFX
	Public Hash As String
	Public PreviousHash As String
	Public MerkleRoot As String
	Public Transactions As List
	Private TimeStamp As Long
	Private nonce As Int = -1
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(pPreviousHash As String)
	Transactions.Initialize
	PreviousHash = pPreviousHash
	TimeStamp = DateTime.Now
	Hash = CalculateHash
End Sub

Public Sub CalculateHash As String
	Dim NonceStr As String = nonce
	If nonce = -1 Then 
		NonceStr = ""
	End If
	Return BCUtils.ApplySha256(PreviousHash & TimeStamp & NonceStr & MerkleRoot)
End Sub

Public Sub MineBlock(Difficulty As String)
	
	Dim DiffInt As Int = Floor(Difficulty)
	Dim Iterations As Int = Difficulty.SubString(Difficulty.IndexOf(".") + 1)
	Log("Iter " & Iterations)
	MerkleRoot = BCUtils.GetMerkleRoot(Transactions)
	
	Dim Target As String = BCUtils.GetDifficultyString(DiffInt)
	nonce = 0
	Dim StartTime As Long = DateTime.Now
	For i = 0 To Iterations - 1
		Do While Not(Hash.substring2(0,DiffInt).EqualsIgnoreCase(Target))
			nonce = nonce + 1
			Hash = CalculateHash		
		Loop
	
	Next
	Log($"Block mined!!! in  ${DateTime.Now - StartTime} ms:   ${Hash} : ${nonce}"$)
	
End Sub

'Add transactions to this block
Public Sub AddTransaction(Trans As Transaction) As Boolean
	'process transaction and check if valid, unless block is genesis block then ignore.
	If Trans = Null Or Trans.IsInitialized = False Then Return False
	
	If PreviousHash <> "0" Then
		If Trans.ProcessTransaction <> True Then
			Log("Transaction failed to process. Discarded")
			Return False
		End If
	End If
	Transactions.Add(Trans)
	Log("Transaction Successfully added to Block")
	Return True
End Sub
