﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.01
@EndOfDesignText@
Sub Class_Globals
	Private fx As JFX
	
	Public PrivateKey As JavaObject
	Public PublicKey As JavaObject
	Public UTXOs As Map
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	UTXOs.Initialize
	GenerateKeyPair
End Sub

Public Sub GenerateKeyPair
	
	'Generate the key pair
	
	Dim KeyPairGenerator As JavaObject
	Dim SecureRandom As JavaObject
	Dim EcSpec As JavaObject
	
	KeyPairGenerator.InitializeStatic("java.security.KeyPairGenerator")
	SecureRandom.InitializeStatic("java.security.SecureRandom")
	
	
	Dim KeyGen As JavaObject = KeyPairGenerator.RunMethod("getInstance",Array("ECDSA","BC"))
	Dim Random As JavaObject = SecureRandom.RunMethod("getInstance",Array("SHA1PRNG"))
	EcSpec.InitializeNewInstance("java.security.spec.ECGenParameterSpec",Array("prime192v1"))
	
	'Initialize the key generator and generate a KeyPair
	KeyGen.RunMethod("initialize",Array(EcSpec, Random))
	
	Dim KeyPair As JavaObject = KeyGen.RunMethod("generateKeyPair",Null)
	
	PrivateKey = KeyPair.RunMethod("getPrivate",Null)
	PublicKey = KeyPair.RunMethod("getPublic",Null)
End Sub

Public Sub GetBalance As Double
	Dim Total As Double = 0
	
	For Each UTXO As TransactionOutput In Main.UTXOs.Values
		If UTXO.IsMine(PublicKey) Then			'if output belongs to me ( if coins belong to me )
			UTXOs.Put(UTXO.Id,UTXO)				'add it to our list of unspent transactions.
			Total = Total + UTXO.Value
		End If
	Next
	
	Return Total
End Sub

Public Sub SendFunds(Recipient As JavaObject, Value As Double) As Transaction
	
	If GetBalance < Value Then
		Log("Not enough funds to send transaction. Transaction discarded")
		Return Null
	End If
	
	'create array list of inputs
	
	Dim Inputs As List
	Inputs.Initialize
	
	Dim Total As Double = 0
	
	For Each UTXO As TransactionOutput In UTXOs.Values
		Total = Total + UTXO.Value
		Dim Inp As TransactionInput
		Inp.Initialize(UTXO.Id)
		Inputs.Add(Inp)
		If Total > Value Then Exit
	Next
	
	Dim NewTransaction As Transaction
	NewTransaction.Initialize(PublicKey,Recipient,Value,Inputs)
	NewTransaction.GenerateSignature(PrivateKey)
	
	For Each input As TransactionInput In Inputs
		UTXOs.Remove(input.TransactionOutputID)
	Next
	
	Return NewTransaction
	
End Sub

